# Description:
#   Control Hyper from hubot
#
# Dependencies:
#   None
#
# Configuration:
#   None
#
# Commands:
#   hubot hyper ps
#   hubot hyper restart <container name>
#
# Author:
#   Jimmy Xu <xjimmyshcn@gmail.com>
#

run_cmd = (cmd, args, cb ) ->
    spawn = require("child_process").spawn
    opts =
        env: {}
    child = spawn(cmd, args, opts)
    child.stdout.on "data", (buffer) -> cb buffer.toString()
    child.stderr.on "data", (buffer) -> cb buffer.toString()

module.exports = (robot) ->
  robot.respond /hyper restart (.*)/i, (msg) ->
    msg.send "Restarting "+msg.match[1].replace(/[\W]+/g, "")+"..."
    run_cmd "hyper", ["restart", msg.match[1].replace(/[\W]+/g, "")], (text) -> msg.send text

  robot.respond /hyper ps$/i, (msg) ->
    run_cmd 'hyper', ['ps','-a','--format="{{.Names}}:\t{{.Status}}"'], (text) -> msg.send text
